/*******************************************************************************
* File Name: P15_5_Reconnect.h  
* Version 1.70
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_P15_5_Reconnect_H) /* Pins P15_5_Reconnect_H */
#define CY_PINS_P15_5_Reconnect_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "P15_5_Reconnect_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    P15_5_Reconnect_Write(uint8 value) ;
void    P15_5_Reconnect_SetDriveMode(uint8 mode) ;
uint8   P15_5_Reconnect_ReadDataReg(void) ;
uint8   P15_5_Reconnect_Read(void) ;
uint8   P15_5_Reconnect_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define P15_5_Reconnect_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define P15_5_Reconnect_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define P15_5_Reconnect_DM_RES_UP          PIN_DM_RES_UP
#define P15_5_Reconnect_DM_RES_DWN         PIN_DM_RES_DWN
#define P15_5_Reconnect_DM_OD_LO           PIN_DM_OD_LO
#define P15_5_Reconnect_DM_OD_HI           PIN_DM_OD_HI
#define P15_5_Reconnect_DM_STRONG          PIN_DM_STRONG
#define P15_5_Reconnect_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define P15_5_Reconnect_MASK               P15_5_Reconnect__MASK
#define P15_5_Reconnect_SHIFT              P15_5_Reconnect__SHIFT
#define P15_5_Reconnect_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define P15_5_Reconnect_PS                     (* (reg8 *) P15_5_Reconnect__PS)
/* Data Register */
#define P15_5_Reconnect_DR                     (* (reg8 *) P15_5_Reconnect__DR)
/* Port Number */
#define P15_5_Reconnect_PRT_NUM                (* (reg8 *) P15_5_Reconnect__PRT) 
/* Connect to Analog Globals */                                                  
#define P15_5_Reconnect_AG                     (* (reg8 *) P15_5_Reconnect__AG)                       
/* Analog MUX bux enable */
#define P15_5_Reconnect_AMUX                   (* (reg8 *) P15_5_Reconnect__AMUX) 
/* Bidirectional Enable */                                                        
#define P15_5_Reconnect_BIE                    (* (reg8 *) P15_5_Reconnect__BIE)
/* Bit-mask for Aliased Register Access */
#define P15_5_Reconnect_BIT_MASK               (* (reg8 *) P15_5_Reconnect__BIT_MASK)
/* Bypass Enable */
#define P15_5_Reconnect_BYP                    (* (reg8 *) P15_5_Reconnect__BYP)
/* Port wide control signals */                                                   
#define P15_5_Reconnect_CTL                    (* (reg8 *) P15_5_Reconnect__CTL)
/* Drive Modes */
#define P15_5_Reconnect_DM0                    (* (reg8 *) P15_5_Reconnect__DM0) 
#define P15_5_Reconnect_DM1                    (* (reg8 *) P15_5_Reconnect__DM1)
#define P15_5_Reconnect_DM2                    (* (reg8 *) P15_5_Reconnect__DM2) 
/* Input Buffer Disable Override */
#define P15_5_Reconnect_INP_DIS                (* (reg8 *) P15_5_Reconnect__INP_DIS)
/* LCD Common or Segment Drive */
#define P15_5_Reconnect_LCD_COM_SEG            (* (reg8 *) P15_5_Reconnect__LCD_COM_SEG)
/* Enable Segment LCD */
#define P15_5_Reconnect_LCD_EN                 (* (reg8 *) P15_5_Reconnect__LCD_EN)
/* Slew Rate Control */
#define P15_5_Reconnect_SLW                    (* (reg8 *) P15_5_Reconnect__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define P15_5_Reconnect_PRTDSI__CAPS_SEL       (* (reg8 *) P15_5_Reconnect__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define P15_5_Reconnect_PRTDSI__DBL_SYNC_IN    (* (reg8 *) P15_5_Reconnect__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define P15_5_Reconnect_PRTDSI__OE_SEL0        (* (reg8 *) P15_5_Reconnect__PRTDSI__OE_SEL0) 
#define P15_5_Reconnect_PRTDSI__OE_SEL1        (* (reg8 *) P15_5_Reconnect__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define P15_5_Reconnect_PRTDSI__OUT_SEL0       (* (reg8 *) P15_5_Reconnect__PRTDSI__OUT_SEL0) 
#define P15_5_Reconnect_PRTDSI__OUT_SEL1       (* (reg8 *) P15_5_Reconnect__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define P15_5_Reconnect_PRTDSI__SYNC_OUT       (* (reg8 *) P15_5_Reconnect__PRTDSI__SYNC_OUT) 


#if defined(P15_5_Reconnect__INTSTAT)  /* Interrupt Registers */

    #define P15_5_Reconnect_INTSTAT                (* (reg8 *) P15_5_Reconnect__INTSTAT)
    #define P15_5_Reconnect_SNAP                   (* (reg8 *) P15_5_Reconnect__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins P15_5_Reconnect_H */


/* [] END OF FILE */
