/*******************************************************************************
* File Name: P5_0_WiFiResetN.c  
* Version 1.70
*
* Description:
*  This file contains API to enable firmware control of a Pins component.
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include "cytypes.h"
#include "P5_0_WiFiResetN.h"


/*******************************************************************************
* Function Name: P5_0_WiFiResetN_Write
********************************************************************************
* Summary:
*  Assign a new value to the digital port's data output register.  
*
* Parameters:  
*  prtValue:  The value to be assigned to the Digital Port. 
*
* Return: 
*  void 
*  
*******************************************************************************/
void P5_0_WiFiResetN_Write(uint8 value) 
{
    uint8 staticBits = P5_0_WiFiResetN_DR & ~P5_0_WiFiResetN_MASK;
    P5_0_WiFiResetN_DR = staticBits | ((value << P5_0_WiFiResetN_SHIFT) & P5_0_WiFiResetN_MASK);
}


/*******************************************************************************
* Function Name: P5_0_WiFiResetN_SetDriveMode
********************************************************************************
* Summary:
*  Change the drive mode on the pins of the port.
* 
* Parameters:  
*  mode:  Change the pins to this drive mode.
*
* Return: 
*  void
*
*******************************************************************************/
void P5_0_WiFiResetN_SetDriveMode(uint8 mode) 
{
	CyPins_SetPinDriveMode(P5_0_WiFiResetN_0, mode);
}


/*******************************************************************************
* Function Name: P5_0_WiFiResetN_Read
********************************************************************************
* Summary:
*  Read the current value on the pins of the Digital Port in right justified 
*  form.
*
* Parameters:  
*  void 
*
* Return: 
*  Returns the current value of the Digital Port as a right justified number
*  
* Note:
*  Macro P5_0_WiFiResetN_ReadPS calls this function. 
*  
*******************************************************************************/
uint8 P5_0_WiFiResetN_Read(void) 
{
    return (P5_0_WiFiResetN_PS & P5_0_WiFiResetN_MASK) >> P5_0_WiFiResetN_SHIFT;
}


/*******************************************************************************
* Function Name: P5_0_WiFiResetN_ReadDataReg
********************************************************************************
* Summary:
*  Read the current value assigned to a Digital Port's data output register
*
* Parameters:  
*  void 
*
* Return: 
*  Returns the current value assigned to the Digital Port's data output register
*  
*******************************************************************************/
uint8 P5_0_WiFiResetN_ReadDataReg(void) 
{
    return (P5_0_WiFiResetN_DR & P5_0_WiFiResetN_MASK) >> P5_0_WiFiResetN_SHIFT;
}


/* If Interrupts Are Enabled for this Pins component */ 
#if defined(P5_0_WiFiResetN_INTSTAT) 

    /*******************************************************************************
    * Function Name: P5_0_WiFiResetN_ClearInterrupt
    ********************************************************************************
    * Summary:
    *  Clears any active interrupts attached to port and returns the value of the 
    *  interrupt status register.
    *
    * Parameters:  
    *  void 
    *
    * Return: 
    *  Returns the value of the interrupt status register
    *  
    *******************************************************************************/
    uint8 P5_0_WiFiResetN_ClearInterrupt(void) 
    {
        return (P5_0_WiFiResetN_INTSTAT & P5_0_WiFiResetN_MASK) >> P5_0_WiFiResetN_SHIFT;
    }

#endif /* If Interrupts Are Enabled for this Pins component */ 


/* [] END OF FILE */ 
