/*******************************************************************************
* File Name: P5_0_WiFiResetN.h  
* Version 1.70
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_P5_0_WiFiResetN_H) /* Pins P5_0_WiFiResetN_H */
#define CY_PINS_P5_0_WiFiResetN_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "P5_0_WiFiResetN_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    P5_0_WiFiResetN_Write(uint8 value) ;
void    P5_0_WiFiResetN_SetDriveMode(uint8 mode) ;
uint8   P5_0_WiFiResetN_ReadDataReg(void) ;
uint8   P5_0_WiFiResetN_Read(void) ;
uint8   P5_0_WiFiResetN_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define P5_0_WiFiResetN_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define P5_0_WiFiResetN_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define P5_0_WiFiResetN_DM_RES_UP          PIN_DM_RES_UP
#define P5_0_WiFiResetN_DM_RES_DWN         PIN_DM_RES_DWN
#define P5_0_WiFiResetN_DM_OD_LO           PIN_DM_OD_LO
#define P5_0_WiFiResetN_DM_OD_HI           PIN_DM_OD_HI
#define P5_0_WiFiResetN_DM_STRONG          PIN_DM_STRONG
#define P5_0_WiFiResetN_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define P5_0_WiFiResetN_MASK               P5_0_WiFiResetN__MASK
#define P5_0_WiFiResetN_SHIFT              P5_0_WiFiResetN__SHIFT
#define P5_0_WiFiResetN_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define P5_0_WiFiResetN_PS                     (* (reg8 *) P5_0_WiFiResetN__PS)
/* Data Register */
#define P5_0_WiFiResetN_DR                     (* (reg8 *) P5_0_WiFiResetN__DR)
/* Port Number */
#define P5_0_WiFiResetN_PRT_NUM                (* (reg8 *) P5_0_WiFiResetN__PRT) 
/* Connect to Analog Globals */                                                  
#define P5_0_WiFiResetN_AG                     (* (reg8 *) P5_0_WiFiResetN__AG)                       
/* Analog MUX bux enable */
#define P5_0_WiFiResetN_AMUX                   (* (reg8 *) P5_0_WiFiResetN__AMUX) 
/* Bidirectional Enable */                                                        
#define P5_0_WiFiResetN_BIE                    (* (reg8 *) P5_0_WiFiResetN__BIE)
/* Bit-mask for Aliased Register Access */
#define P5_0_WiFiResetN_BIT_MASK               (* (reg8 *) P5_0_WiFiResetN__BIT_MASK)
/* Bypass Enable */
#define P5_0_WiFiResetN_BYP                    (* (reg8 *) P5_0_WiFiResetN__BYP)
/* Port wide control signals */                                                   
#define P5_0_WiFiResetN_CTL                    (* (reg8 *) P5_0_WiFiResetN__CTL)
/* Drive Modes */
#define P5_0_WiFiResetN_DM0                    (* (reg8 *) P5_0_WiFiResetN__DM0) 
#define P5_0_WiFiResetN_DM1                    (* (reg8 *) P5_0_WiFiResetN__DM1)
#define P5_0_WiFiResetN_DM2                    (* (reg8 *) P5_0_WiFiResetN__DM2) 
/* Input Buffer Disable Override */
#define P5_0_WiFiResetN_INP_DIS                (* (reg8 *) P5_0_WiFiResetN__INP_DIS)
/* LCD Common or Segment Drive */
#define P5_0_WiFiResetN_LCD_COM_SEG            (* (reg8 *) P5_0_WiFiResetN__LCD_COM_SEG)
/* Enable Segment LCD */
#define P5_0_WiFiResetN_LCD_EN                 (* (reg8 *) P5_0_WiFiResetN__LCD_EN)
/* Slew Rate Control */
#define P5_0_WiFiResetN_SLW                    (* (reg8 *) P5_0_WiFiResetN__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define P5_0_WiFiResetN_PRTDSI__CAPS_SEL       (* (reg8 *) P5_0_WiFiResetN__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define P5_0_WiFiResetN_PRTDSI__DBL_SYNC_IN    (* (reg8 *) P5_0_WiFiResetN__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define P5_0_WiFiResetN_PRTDSI__OE_SEL0        (* (reg8 *) P5_0_WiFiResetN__PRTDSI__OE_SEL0) 
#define P5_0_WiFiResetN_PRTDSI__OE_SEL1        (* (reg8 *) P5_0_WiFiResetN__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define P5_0_WiFiResetN_PRTDSI__OUT_SEL0       (* (reg8 *) P5_0_WiFiResetN__PRTDSI__OUT_SEL0) 
#define P5_0_WiFiResetN_PRTDSI__OUT_SEL1       (* (reg8 *) P5_0_WiFiResetN__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define P5_0_WiFiResetN_PRTDSI__SYNC_OUT       (* (reg8 *) P5_0_WiFiResetN__PRTDSI__SYNC_OUT) 


#if defined(P5_0_WiFiResetN__INTSTAT)  /* Interrupt Registers */

    #define P5_0_WiFiResetN_INTSTAT                (* (reg8 *) P5_0_WiFiResetN__INTSTAT)
    #define P5_0_WiFiResetN_SNAP                   (* (reg8 *) P5_0_WiFiResetN__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins P5_0_WiFiResetN_H */


/* [] END OF FILE */
