/*******************************************************************************
* File Name: TX_Debug.h  
* Version 1.70
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_TX_Debug_H) /* Pins TX_Debug_H */
#define CY_PINS_TX_Debug_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "TX_Debug_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    TX_Debug_Write(uint8 value) ;
void    TX_Debug_SetDriveMode(uint8 mode) ;
uint8   TX_Debug_ReadDataReg(void) ;
uint8   TX_Debug_Read(void) ;
uint8   TX_Debug_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define TX_Debug_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define TX_Debug_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define TX_Debug_DM_RES_UP          PIN_DM_RES_UP
#define TX_Debug_DM_RES_DWN         PIN_DM_RES_DWN
#define TX_Debug_DM_OD_LO           PIN_DM_OD_LO
#define TX_Debug_DM_OD_HI           PIN_DM_OD_HI
#define TX_Debug_DM_STRONG          PIN_DM_STRONG
#define TX_Debug_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define TX_Debug_MASK               TX_Debug__MASK
#define TX_Debug_SHIFT              TX_Debug__SHIFT
#define TX_Debug_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define TX_Debug_PS                     (* (reg8 *) TX_Debug__PS)
/* Data Register */
#define TX_Debug_DR                     (* (reg8 *) TX_Debug__DR)
/* Port Number */
#define TX_Debug_PRT_NUM                (* (reg8 *) TX_Debug__PRT) 
/* Connect to Analog Globals */                                                  
#define TX_Debug_AG                     (* (reg8 *) TX_Debug__AG)                       
/* Analog MUX bux enable */
#define TX_Debug_AMUX                   (* (reg8 *) TX_Debug__AMUX) 
/* Bidirectional Enable */                                                        
#define TX_Debug_BIE                    (* (reg8 *) TX_Debug__BIE)
/* Bit-mask for Aliased Register Access */
#define TX_Debug_BIT_MASK               (* (reg8 *) TX_Debug__BIT_MASK)
/* Bypass Enable */
#define TX_Debug_BYP                    (* (reg8 *) TX_Debug__BYP)
/* Port wide control signals */                                                   
#define TX_Debug_CTL                    (* (reg8 *) TX_Debug__CTL)
/* Drive Modes */
#define TX_Debug_DM0                    (* (reg8 *) TX_Debug__DM0) 
#define TX_Debug_DM1                    (* (reg8 *) TX_Debug__DM1)
#define TX_Debug_DM2                    (* (reg8 *) TX_Debug__DM2) 
/* Input Buffer Disable Override */
#define TX_Debug_INP_DIS                (* (reg8 *) TX_Debug__INP_DIS)
/* LCD Common or Segment Drive */
#define TX_Debug_LCD_COM_SEG            (* (reg8 *) TX_Debug__LCD_COM_SEG)
/* Enable Segment LCD */
#define TX_Debug_LCD_EN                 (* (reg8 *) TX_Debug__LCD_EN)
/* Slew Rate Control */
#define TX_Debug_SLW                    (* (reg8 *) TX_Debug__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define TX_Debug_PRTDSI__CAPS_SEL       (* (reg8 *) TX_Debug__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define TX_Debug_PRTDSI__DBL_SYNC_IN    (* (reg8 *) TX_Debug__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define TX_Debug_PRTDSI__OE_SEL0        (* (reg8 *) TX_Debug__PRTDSI__OE_SEL0) 
#define TX_Debug_PRTDSI__OE_SEL1        (* (reg8 *) TX_Debug__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define TX_Debug_PRTDSI__OUT_SEL0       (* (reg8 *) TX_Debug__PRTDSI__OUT_SEL0) 
#define TX_Debug_PRTDSI__OUT_SEL1       (* (reg8 *) TX_Debug__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define TX_Debug_PRTDSI__SYNC_OUT       (* (reg8 *) TX_Debug__PRTDSI__SYNC_OUT) 


#if defined(TX_Debug__INTSTAT)  /* Interrupt Registers */

    #define TX_Debug_INTSTAT                (* (reg8 *) TX_Debug__INTSTAT)
    #define TX_Debug_SNAP                   (* (reg8 *) TX_Debug__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins TX_Debug_H */


/* [] END OF FILE */
